Spatial - Post Closest Point
Applies to: S1 pricing tier.
This API returns the closest point between a base point and a given set of target points. The set of target points is provided by user data in post request body. The user data may only contain a collection of Point geometry. MultiPoint or other geometries will be ignored if provided. The algorithm does not take into account routing or traffic. The maximum number of points accepted is 100,000. Information returned includes closest point latitude, longitude, and distance in meters from the closest point.
POST https://{geography}.atlas.microsoft.com/spatial/closestPoint/json?api-version=1.0&lat={lat}&lon={lon}
POST https://{geography}.atlas.microsoft.com/spatial/closestPoint/json?api-version=1.0&lat={lat}&lon={lon}&numberOfClosestPoints={numberOfClosestPoints}
URI Parameters
| Name | In | Required | Type | Description |
|---|---|---|---|---|
|
format
|
path | True |
Desired format of the response. Only |
|
|
geography
|
path | True |
|
This parameter specifies where the Azure Maps Creator resource is located. Valid values are us and eu. |
|
api-version
|
query | True |
|
Version number of Azure Maps API. |
|
lat
|
query | True |
|
The latitude of the location being passed. Example: 48.36. |
|
lon
|
query | True |
|
The longitude of the location being passed. Example: -124.63. |
|
number
|
query |
|
The number of closest points expected from response. Default: 1, minimum: 1 and maximum: 50 |
Request Header
| Name | Required | Type | Description |
|---|---|---|---|
| x-ms-client-id |
|
Specifies which account is intended for usage in conjunction with the Azure AD security model. It represents a unique ID for the Azure Maps account and can be retrieved from the Azure Maps management plane Account API. To use Azure AD security in Azure Maps see the following articles for guidance. |
Request Body
| Name | Required | Type | Description |
|---|---|---|---|
| features | True |
Contains a list of valid |
|
| type | True |
string:
|
Specifies the |
Responses
| Name | Type | Description |
|---|---|---|
| 200 OK |
OK |
|
| Other Status Codes |
An unexpected error occurred. |
Security
AADToken
These are the Azure Active Directory OAuth2 Flows. When paired with Azure role-based access control it can be used to control access to Azure Maps REST APIs. Azure role-based access controls are used to designate access to one or more Azure Maps resource account or sub-resources. Any user, group, or service principal can be granted access via a built-in role or a custom role composed of one or more permissions to Azure Maps REST APIs.
To implement scenarios, we recommend viewing authentication concepts. In summary, this security definition provides a solution for modeling application(s) via objects capable of access control on specific APIs and scopes.
Notes
- This security definition requires the use of the
x-ms-client-idheader to indicate which Azure Maps resource the application is requesting access to. This can be acquired from the Maps management API.
The Authorization URL is specific to the Azure public cloud instance. Sovereign clouds have unique Authorization URLs and Azure Active directory configurations.
*
The Azure role-based access control is configured from the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
*
Usage of the Azure Maps Web SDK allows for configuration based setup of an application for multiple use cases.
- Currently, Azure Active Directory v1.0 or v2.0 supports Work, School, and Guests but does not support Personal accounts.
Type:
oauth2
Flow:
implicit
Authorization URL:
https://login.microsoftonline.com/common/oauth2/authorize
Scopes
| Name | Description |
|---|---|
| https://atlas.microsoft.com/.default | https://atlas.microsoft.com/.default |
subscription-key
This is a shared key that is provisioned when creating an Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this key, any application is authorized to access all REST APIs. In other words, these can currently be treated as master keys to the account which they are issued for.
For publicly exposed applications, our recommendation is to use server-to-server access of Azure Maps REST APIs where this key can be securely stored.
Type:
apiKey
In:
query
SAS Token
This is a shared access signature token is created from the List SAS operation on the Azure Maps resource through the Azure management plane via Azure portal, PowerShell, CLI, Azure SDKs, or REST APIs.
With this token, any application is authorized to access with Azure role-based access controls and fine-grain control to the expiration, rate, and region(s) of use for the particular token. In other words, the SAS Token can be used to allow applications to control access in a more secured way than the shared key.
For publicly exposed applications, our recommendation is to configure a specific list of allowed origins on the Map account resource to limit rendering abuse and regularly renew the SAS Token.
Type:
apiKey
In:
header
Examples
PostClosestPoint
Sample Request
POST https://us.atlas.microsoft.com/spatial/closestPoint/json?api-version=1.0&lat=47.622942&lon=-122.316456
{
"type": "FeatureCollection",
"features": [
{
"type": "Feature",
"properties": {
"geometryId": 1001
},
"geometry": {
"type": "Point",
"coordinates": [
-105.02860293715861,
40.51615340677395
]
}
},
{
"type": "Feature",
"properties": {
"geometryId": 1002
},
"geometry": {
"type": "Point",
"coordinates": [
-105.02860381672178,
40.51599099003731
]
}
},
{
"type": "Feature",
"properties": {
"geometryId": 1003
},
"geometry": {
"type": "Point",
"coordinates": [
-105.02812292879467,
40.51605867808856
]
}
}
]
}
Sample Response
{
"summary": {
"sourcePoint": {
"lat": 47.622942,
"lon": -122.316456
},
"udid": null,
"information": "3 points processed in user data"
},
"result": [
{
"distanceInMeters": 1587492.66,
"position": {
"lat": 40.51615340677395,
"lon": -105.02860293715861
},
"geometryId": "1001"
}
]
}
Definitions
|
Closest |
Closest Point Result Entry Object |
|
Closest |
This object is returned from a successful Spatial Closest Point call |
|
Closest |
Closest Point Summary object |
|
Error |
The resource management error additional info. |
|
Error |
The error detail. |
|
Error |
Error response |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Geo |
A valid |
|
Json |
Desired format of the response. Only |
|
Lat |
A location represented as a latitude and longitude using short names 'lat' & 'lon'. |
ClosestPoint
Closest Point Result Entry Object
| Name | Type | Description |
|---|---|---|
| distanceInMeters |
|
The distance in meters from the source point to the closest point |
| geometryId |
|
The unique id identifies a geometry |
| position |
A location represented as a latitude and longitude using short names 'lat' & 'lon'. |
ClosestPointResponse
This object is returned from a successful Spatial Closest Point call
| Name | Type | Description |
|---|---|---|
| result |
Closest Point Result Array |
|
| summary |
Closest Point Summary object |
ClosestPointSummary
Closest Point Summary object
| Name | Type | Description |
|---|---|---|
| information |
|
Processing information |
| sourcePoint |
A location represented as a latitude and longitude using short names 'lat' & 'lon'. |
|
| udid |
|
A unique data id (udid) for the uploaded content |
ErrorAdditionalInfo
The resource management error additional info.
| Name | Type | Description |
|---|---|---|
| info |
|
The additional info. |
| type |
|
The additional info type. |
ErrorDetail
The error detail.
| Name | Type | Description |
|---|---|---|
| additionalInfo |
The error additional info. |
|
| code |
|
The error code. |
| details |
The error details. |
|
| message |
|
The error message. |
| target |
|
The error target. |
ErrorResponse
Error response
| Name | Type | Description |
|---|---|---|
| error |
The error object. |
GeoJsonFeature
A valid GeoJSON Feature object type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| featureType |
|
The type of the feature. The value depends on the data model the current feature is part of. Some data models may have an empty value. |
| geometry | GeoJsonGeometry: |
A valid |
| id |
|
Identifier for the feature. |
| type |
string:
|
Specifies the |
GeoJsonFeatureCollection
A valid GeoJSON FeatureCollection object type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| features |
Contains a list of valid |
|
| type |
string:
|
Specifies the |
GeoJsonGeometry
A valid GeoJSON geometry object. The type must be one of the seven valid GeoJSON geometry types - Point, MultiPoint, LineString, MultiLineString, Polygon, MultiPolygon and GeometryCollection. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| type |
|
Specifies the |
GeoJsonGeometryCollection
A valid GeoJSON GeometryCollection object type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| geometries | GeoJsonGeometry[]: |
Contains a list of valid |
| type |
string:
|
Specifies the |
GeoJsonLineString
A valid GeoJSON LineString geometry type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
Coordinates for the |
| type |
string:
|
Specifies the |
GeoJsonMultiLineString
A valid GeoJSON MultiLineString geometry type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
Coordinates for the |
| type |
string:
|
Specifies the |
GeoJsonMultiPoint
A valid GeoJSON MultiPoint geometry type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
Coordinates for the |
| type |
string:
|
Specifies the |
GeoJsonMultiPolygon
A valid GeoJSON MultiPolygon object type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
Contains a list of valid |
| type |
string:
|
Specifies the |
GeoJsonPoint
A valid GeoJSON Point geometry type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
A |
| type |
string:
|
Specifies the |
GeoJsonPolygon
A valid GeoJSON Polygon geometry type. Please refer to RFC 7946 for details.
| Name | Type | Description |
|---|---|---|
| coordinates |
|
Coordinates for the |
| type |
string:
|
Specifies the |
JsonFormat
Desired format of the response. Only json format is supported.
| Name | Type | Description |
|---|---|---|
| json |
|
LatLongPairAbbreviated
A location represented as a latitude and longitude using short names 'lat' & 'lon'.
| Name | Type | Description |
|---|---|---|
| lat |
|
Latitude property |
| lon |
|
Longitude property |